﻿using ProjectAirBomber.Entities;

namespace ProjectAirBomber.Drawnings;

/// <summary>
/// Класс, отвечающий за прорисовку и перемещение объекта-сущности
/// </summary>
public class DrawningAirBomber : DrawningBomber
{

    /// <summary>
    /// Конструктор 
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="fuelTanks">Признак наличия дополнительных топливных баков</param>
    /// <param name="bombs">Признак наличия бомб</param>




    //TO DO!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    public DrawningAirBomber(int speed, double weight, Color bodyColor, Color additionalColor, bool fuelTanks, bool bombs, bool v) : base(200, 160)
    {
        EntityBomber = new EntityAirBomber(speed, weight, bodyColor, additionalColor, fuelTanks, bombs);
    }



    public override void DrawTransport(Graphics g)
    {
        if (EntityBomber == null || EntityBomber is not EntityAirBomber airBomber || !_startPosX.HasValue || !_startPosY.HasValue)
        {
            return;
        }

        Pen pen = new(Color.Black);
        Brush additionalBrush = new SolidBrush(airBomber.AdditionalColor);

        // топливные баки
        if (airBomber.FuelTanks)
        {
            g.FillRectangle(additionalBrush, _startPosX.Value + 90, _startPosY.Value + 20, 20, 20);
            g.FillRectangle(additionalBrush, _startPosX.Value + 90, _startPosY.Value + 110, 20, 20);
        }

        // бомбы
        if (airBomber.Bombs)
        {
            g.FillPolygon(additionalBrush, new Point[]
            {
                new Point(_startPosX.Value + 110, _startPosY.Value + 42),
                new Point(_startPosX.Value + 110, _startPosY.Value + 60),
                new Point(_startPosX.Value + 80, _startPosY.Value + 50)
            });

            g.FillPolygon(additionalBrush, new Point[]
            {
                new Point(_startPosX.Value + 110, _startPosY.Value + 90),
                new Point(_startPosX.Value + 110, _startPosY.Value + 108),
                new Point(_startPosX.Value + 80, _startPosY.Value + 100)
            });
        }

        _startPosX += 10;
        _startPosY += 5;
        base.DrawTransport(g);
        _startPosX -= 10;
        _startPosY -= 5;

       
    }
}