﻿namespace ProjectAirBomber.Entities;

/// <summary>
/// Класс-сущность "Бомбардировщик"
/// </summary>
public class EntityAirBomber : EntityBomber
{
    public EntityAirBomber(int speed, double weight, Color bodyColor, Color additionalColor, bool fuelTanks, bool bombs) : base(speed, weight, bodyColor)
    {
    }


    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }

    /// <summary>
    /// Признак (опция) наличия дополнительных топливных баков
    /// </summary>
    public bool FuelTanks { get; private set; }

    /// <summary>
    /// Признак (опция) наличия бомб
    /// </summary>
    public bool Bombs { get; private set; }

    /// <summary>
    /// Шаг перемещения бомбардировщика
    /// </summary>
    public double Step => Speed * 200 / Weight;

    public bool FuelTank { get; internal set; }

    /// <summary>
    /// Инициализация полей объекта-класса бомбардировщика
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес бомбардировщика</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="fuelTanks">Признак наличия дополнительных топливных баков</param>
    /// <param name="bombs">Признак наличия бомб</param>
    public void Init(int speed, double weight, Color bodyColor, Color additionalColor, bool fuelTanks, bool bombs)
    {
        AdditionalColor = additionalColor;
        FuelTanks = fuelTanks;
        Bombs = bombs;
    }
}