﻿using ProjectAirBomber.Drawnings;

namespace ProjectAirBomber;

/// <summary>
/// Форма работы с объектом "Бомбардировщик"
/// </summary>
public partial class FormAirBomber : Form
{
    /// <summary>
    /// Поле-объект для прорисовки объекта
    /// </summary>
    private DrawningBomber? _drawningBomber;

    /// <summary>
    /// Конструктор формы
    /// </summary>
    public FormAirBomber()
    {
        InitializeComponent();
    }
    /// <summary>
    /// Метод прорисовки бомбардировщика
    /// </summary>
    private void Draw()
    {
        if (_drawningBomber == null)
        {
            return;
        }

        Bitmap bmp = new(pictureBoxAirBomber.Width, pictureBoxAirBomber.Height);
        Graphics gr = Graphics.FromImage(bmp);
        _drawningBomber.DrawTransport(gr);
        pictureBoxAirBomber.Image = bmp;
    }

    private void CreateObject(string type)
    {
        Random random = new();
        switch (type)
        {
            case nameof(DrawningBomber):
                _drawningBomber = new DrawningBomber(random.Next(100, 300), random.Next(1000, 3000),
                    Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)));
                break;
            case nameof(DrawningAirBomber):
                _drawningBomber = new DrawningAirBomber(random.Next(100, 300), random.Next(1000, 3000),
                    Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                    Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                    Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
                break;
            default:
                return;
        }

        _drawningBomber.SetPictureSize(pictureBoxAirBomber.Width, pictureBoxAirBomber.Height);
        _drawningBomber.SetPosition(random.Next(10, 100), random.Next(10, 100));


        Draw();
    }


    /// <summary>
    /// Обработка нажатия кнопки "Создать военный самолёт"
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonCreateAirBomber_Click(object sender, EventArgs e) => CreateObject(nameof(DrawningAirBomber));

    /// <summary>
    /// Обработка нажатия кнопки "Создать самолёт"
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>

    private void buttonCreateBomber_Click(object sender, EventArgs e) => CreateObject(nameof(DrawningBomber));

    /// <summary>
    /// Перемещение объекта по форме (нажатие кнопок навигации)
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonMove_Click(object sender, EventArgs e)
    {
        if (_drawningBomber == null)
        {
            return;
        }

        string name = ((Button)sender)?.Name ?? string.Empty;
        bool result = false;
        switch (name)
        {
            case "buttonUp":
                result = _drawningBomber.MoveTransport(DirectionType.Up);
                break;
            case "buttonDown":
                result = _drawningBomber.MoveTransport(DirectionType.Down);
                break;
            case "buttonLeft":
                result = _drawningBomber.MoveTransport(DirectionType.Left);
                break;
            case "buttonRight":
                result = _drawningBomber.MoveTransport(DirectionType.Right);
                break;
        }

        if (result)
        {
            Draw();
        }
    }

    


}